package Hooke;

import java.io.*;
import java.util.Scanner;

public class Experiment {
   public static void main (String [] argv) throws IOException {
       PrintStream ps = null;
       File file = null;

       float delta = ingresaDelta();
       float tiempo = ingresaTiempo();
       float tiempoMuestreo = ingresaMuestreo();

       if(argv.length != 0){

        file= new File(argv[0]);
        try {
            ps = new PrintStream(new BufferedOutputStream(new FileOutputStream(file)), true);
            System.setOut(ps);
        } catch (FileNotFoundException ex) {
            System.out.println("Ocurrio un problema al intentar abrir el archivo");
        }
       }

	
PhysicsElement[] element = new PhysicsElement[5];
      
Vector2D pos1 = new Vector2D(0f, 0f);         //posicion del bloque 1     
Vector2D pos2 = new Vector2D(2f, -1f);         //posicion del bloque 2
Vector2D pos3 = new Vector2D(1f, 1f);         //posicion del bloque 3 

Vector2D vel1 = new Vector2D(0f, 0f);         //velocidad del resorte 1
Vector2D vel2 = new Vector2D(0f, 0f);         //velocidad del resorte 2 
Vector2D vel3 = new Vector2D(0f, 0f);         //velocidad del resorte 3

Block b1 = new Block(1e15f, 0f, pos1, vel1);   
Block b2 = new Block(1f,    0f, pos2, vel2);  
Block b3 = new Block(1e15f, 0f, pos3, vel3);

Spring spring_a = new Spring (1f, 1f);  // rest length and stiffness
Spring spring_b = new Spring (1f, 1f);  // rest length and stiffness

spring_a.attachLeftBlock(b1);    
spring_a.attachRigthBlock(b2);
spring_b.attachLeftBlock(b2);
spring_b.attachRigthBlock(b3);

b1.attachRightSpring (spring_a);  
b2.attachLeftSpring (spring_a);
b2.attachRightSpring (spring_b); 
b3.attachLeftSpring (spring_b);

element[0] = b1;
element[1] = spring_a;
element[2] = b2;
element[3] = spring_b;
element[4] = b3;      


      
      Simulator sim = new Simulator (); // do not change this class, 
                                        //Thanks to inheritance code can be reuse. 
      sim.setPhysicsElements(element);
      sim.simulate(delta, tiempo, tiempoMuestreo);

     if(ps != null) ps.close();
   }
      private static float ingresaDelta()throws IOException{
      Scanner s = new Scanner (System.in);
      System.out.print("Ingrese delta: ");
      float delta = s.nextFloat();
      return delta;

   }
      private static float ingresaTiempo()throws IOException{
      Scanner s = new Scanner (System.in);
      System.out.print("Ingrese tiempo a simular: ");
      float tiempo = s.nextFloat();
      return tiempo;

   }
      private static float ingresaMuestreo()throws IOException{
      Scanner s = new Scanner (System.in);
      System.out.print("Ingrese tiempo entre escrituras en la salida del estado del sistema: ");
      float muestreo = s.nextFloat();
      return muestreo;

   }
}    
